package com.example.printerdemo;

import java.io.IOException;
import java.io.UnsupportedEncodingException;

import android.app.Activity;
import android.media.SoundPool;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.serialport.SerialPort;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

public class PrinterActivity extends Activity implements OnClickListener {

	private int position;
	private int id;

	private static final String TAG = "SerialPort";

	private SerialPort printer;
	private SerialPort barcode;
	// private BarcodeDemoActivity read;
	private ReadThread read;
	private Handler handler = null;
	private int printer_fd;
	private int barcode_fd;
	private boolean barcode_flog = false;
	private String buf = new String();
	private String buf1 = new String();
	private SoundPool soundPool;
	// public Button close, print, printstring, bitmap;
	public static Button print;
	public Button scan;
	private Button printstring;
	private Button bitmap;
	private Button close;
	private TextView Msg;
	private static final String[] m_high = { "1cm", "2cm", "3cm", "4cm", "5cm" };
	private static final String[] m_wide = { "0.25mm", "0.375mm" };
	private static final String[] bar_type = { "EAN8", "EAN13", "Code39",
			"Code128" };
	private int bar_type_flog = 0;
	private String[] m_Countries;
	private Spinner h_Spinner;
	private Spinner w_Spinner;
	private Spinner m_Spinner;
	private Spinner barType_Spinner;
	public static EditText m_EditText;
	private EditText s_EditText;
	private byte[] cmd10;
	private byte[] cmdS1;
	private byte[] cmdS2;
	private byte[] cmdS3;
	private Print pprint;
	private byte[] S;
	private int flog = 0;
	private int off = 0;
	// int b = a.length;
	ArrayAdapter<String> adapter;
	ArrayAdapter<String> adapter1;
	ArrayAdapter<String> adapter2;
	ArrayAdapter<String> adapter_type;
	// private ArrayAdapter<String> adapter;
	private DeviceControl DevCtrl;
	private DeviceControl DevCtr2;

	public int getPosition() {
		return (position);

	}

	private int getid() {
		return (id);

	}

	public void DisplayToast(String str) {
		Toast toast = Toast.makeText(this, str, Toast.LENGTH_SHORT);
		toast.setGravity(Gravity.TOP, 0, 220);
		toast.show();
	}

	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.printer);
		initUI();

		barcode = new SerialPort();// ("/dev/eser0",9600);
		try {
			barcode.OpenSerial("/dev/eser0", 9600);
			DevCtr2 = new DeviceControl("/proc/driver/scan");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		pprint = new Print(this);
		handler = new Handler() {
			@Override
			public void handleMessage(Message msg) {
				super.handleMessage(msg);
				if (msg.what == 1) {
					m_EditText.setText(buf1);// (buf1);
				}
			}
		};

		m_Countries = new String[2];
		m_Countries[0] = getString(R.string.noprtnum);
		m_Countries[1] = getString(R.string.prtnum);
		adapter = new ArrayAdapter<String>(this,
				android.R.layout.simple_spinner_item, m_Countries);
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

		m_Spinner.setAdapter(adapter);

		m_Spinner
				.setOnItemSelectedListener(new Spinner.OnItemSelectedListener() {
					@Override
					public void onItemSelected(AdapterView<?> arg0, View arg1,
							int position, long id) {
						getPosition();
						getid();
						arg0.setVisibility(View.VISIBLE);
						if (position == 0 && id == 0) {
							pprint.setHRI((byte) 0);

						} else if (position == 1 && id == 1) {
							pprint.setHRI((byte) 2);
							// Log.e("TAG","print number");
						}

						// getPosition();
					}

					@Override
					public void onNothingSelected(AdapterView<?> arg0) {
						// TODO Auto-generated method stub
					}

				});
		adapter1 = new ArrayAdapter<String>(this,
				android.R.layout.simple_spinner_item, m_wide);
		// Log.w(TAG,"WARN");
		adapter1.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		w_Spinner.setAdapter(adapter1);
		w_Spinner
				.setOnItemSelectedListener(new Spinner.OnItemSelectedListener() {

					@Override
					public void onItemSelected(AdapterView<?> arg0, View arg1,
							int position, long id) {
						arg0.setVisibility(View.VISIBLE);
						if (position == 0 && id == 0) {
							pprint.setWide((byte) 2);

						} else if (position == 1 && id == 1) {
							pprint.setWide((byte) 3);

						}
					}

					@Override
					public void onNothingSelected(AdapterView<?> arg0) {
						// TODO Auto-generated method stub
					}

				});
		adapter_type = new ArrayAdapter<String>(this,
				android.R.layout.simple_spinner_item, bar_type);
		// Log.w(TAG,"WARN");
		adapter_type
				.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		barType_Spinner.setAdapter(adapter_type);
		barType_Spinner
				.setOnItemSelectedListener(new Spinner.OnItemSelectedListener() {

					@Override
					public void onItemSelected(AdapterView<?> arg0, View arg1,
							int position, long id) {
						arg0.setVisibility(View.VISIBLE);
						if (position == 0 && id == 0) {
							bar_type_flog = 1;

						} else if (position == 1 && id == 1) {
							bar_type_flog = 2;

						} else if (position == 2 && id == 2) {
							bar_type_flog = 3;

						} else if (position == 3 && id == 3) {
							bar_type_flog = 4;
						}
					}

					@Override
					public void onNothingSelected(AdapterView<?> arg0) {
						// TODO Auto-generated method stub
					}

				});

		adapter2 = new ArrayAdapter<String>(this,
				android.R.layout.simple_spinner_item, m_high);
		adapter2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		h_Spinner.setAdapter(adapter2);
		h_Spinner
				.setOnItemSelectedListener(new Spinner.OnItemSelectedListener() {

					@Override
					public void onItemSelected(AdapterView<?> arg0, View arg1,
							int position, long id) {
						arg0.setVisibility(View.VISIBLE);
						if (position == 0 && id == 0) {
							// System.out.println("hight_set_0");
							pprint.setHight((byte) 55);

						} else if (position == 1 && id == 1) {
							pprint.setHight((byte) 110);

						} else if (position == 2 && id == 2) {
							pprint.setHight((byte) 162);
						} else if (position == 3 && id == 3) {
							pprint.setHight((byte) 200);

						} else if (position == 4 && id == 4) {
							pprint.setHight((byte) 255);

						}
					}

					@Override
					public void onNothingSelected(AdapterView<?> arg0) {
						// TODO Auto-generated method stub
					}

				});
		m_Spinner.setSelection(1);
		h_Spinner.setSelection(0);
		w_Spinner.setSelection(0);

	}

	private void initUI() {
		m_Spinner = (Spinner) findViewById(R.id.spinner);
		h_Spinner = (Spinner) findViewById(R.id.high);
		w_Spinner = (Spinner) findViewById(R.id.wide);
		barType_Spinner = (Spinner) findViewById(R.id.spinner_bar_type);
		barType_Spinner.setSelection(3);
		m_Spinner.setSelection(1);
		h_Spinner.setSelection(0);
		w_Spinner.setSelection(0);

		Msg = (TextView) findViewById(R.id.textView_msg);
		close = (Button) findViewById(R.id.close);
		close.setOnClickListener((OnClickListener) this/* new ClickEvent() */);
		scan = (Button) findViewById(R.id.scan);
		scan.setOnClickListener((OnClickListener) this/* new ClickEvent() */);
		// scan.setVisibility(View.INVISIBLE);
		// 判断是不是4500
		if (!BindDevice.judgeDevice()) {
			scan.setVisibility(View.INVISIBLE);
		} else {
			scan.setVisibility(View.VISIBLE);
		}
		print = (Button) findViewById(R.id.print);
		print.setOnClickListener((OnClickListener) this);
		bitmap = (Button) findViewById(R.id.bitmap);
		bitmap.setOnClickListener((OnClickListener) this);
		// print.setEnabled(false);
		printstring = (Button) findViewById(R.id.buttonS);
		printstring.setOnClickListener((OnClickListener) this);
		s_EditText = (EditText) findViewById(R.id.string);
		s_EditText.setEnabled(true);
		m_EditText = (EditText) findViewById(R.id.edit);
		m_EditText.setEnabled(true);
	}

	public void onDestory() {
		Log.e(TAG, "onDestory");
		// printer.CloseSerial(printer_fd);
		closeBarcode();
		pprint.closePrint();
		super.onDestroy();
	}

	private void closeBarcode() {
		if (read != null) {
			read.interrupt();
		}
		barcode.CloseSerial(barcode_fd);
		try {
			DevCtr2.PowerOffDevice();
			DevCtr2.TriggerOffDevice();
			System.out.println("close barcode");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void onPause() {
		super.onPause();
		Log.e(TAG, "onPause");
//		closeBarcode();
		pprint.powerOffPrint();
		// read = new ReadThread();
		if (read != null) {
			read.interrupt();
		}
	}

	public void onResume() {
		super.onResume();
		pprint.powerOnPrint();
		Log.w(TAG, "onResume");
		m_Spinner.setSelection(1);
		w_Spinner.setSelection(0);
		h_Spinner.setSelection(0);
		SystemClock.sleep(1000);
		pprint.setHRI((byte) 2);
		pprint.setWide((byte) 2);
		pprint.setHight((byte) 55);
	}

	public class ReadThread extends Thread {

		@Override
		public void run() {
			super.run();
			try {
				DevCtr2.PowerOnDevice();
				DevCtr2.TriggerOnDevice();
			} catch (SecurityException e1) {
				e1.printStackTrace();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
			barcode_fd = barcode.getFd();
			while (!isInterrupted()) {
				try {
					buf = barcode.ReadSerialString(barcode_fd, 1024);
					if (buf != null) {
						Message msg = new Message();
						msg.what = 1;
						handler.sendMessage(msg);
						buf1 = buf1 + buf;
					} else {
						Message msg = new Message();
						msg.what = 0;
						handler.sendMessage(msg);
					}
				} catch (SecurityException e) {
					e.printStackTrace();
				} catch (UnsupportedEncodingException e) {
					e.printStackTrace();
				}
			}
		}
	}

	public void onClick(View v) {
		// TODO Auto-generated method stub
		if (v == close) {
			Log.d(TAG, "close" + barcode_flog);
			closeBarcode();
			if (barcode_flog == true) {

			}
			pprint.closePrint();
			finish();
		} else if (v == scan) {
			buf1 = "";
			// barcode_flog = true;
			m_EditText.setText(buf1);
			if (read != null) {
				read.interrupt();
				read = null;
			}
			read = new ReadThread();
			read.start();

		} else if (v == print) {
			String print_data = m_EditText.getText().toString().trim();
			if ("".equals(print_data)) {
				Toast.makeText(
						PrinterActivity.this,
						PrinterActivity.this.getResources().getString(
								R.string.can_not_null), 1).show();
				return;
			}
			print_data = print_data.replaceAll("\n", "");
			if (bar_type_flog == 1) {
				pprint.printEAN8Barcode(print_data);
			} else if (bar_type_flog == 2) {
				pprint.printEAN13Barcode(print_data);
			} else if (bar_type_flog == 3) {
				if (print_data.length() > 7) {
					Toast.makeText(
							PrinterActivity.this,
							PrinterActivity.this.getResources().getString(
									R.string.code39_warning), 1).show();
					return;
				}
				pprint.printCode39Barcode(print_data);
			} else if (bar_type_flog == 4) {
				if (print_data.length() > 14) {
					Toast.makeText(
							PrinterActivity.this,
							PrinterActivity.this.getResources().getString(
									R.string.code128_warning), 1).show();
					return;
				}
				// 只示例code128条码类型中的CODEA
				String data = "a" + print_data;
				pprint.printCode128Barcode(data);
			}
		} else if (v == printstring) {
			pprint.printString(s_EditText.getText().toString());
			// sp.WriteSerialByte(cmdS1);
		}
		if (v == bitmap) {
			pprint.printBitMap();
		}
	}

	public String bystesToStr(byte[] s, int start, int len) {
		// CLogger.Write(s.Length + " start:" + start + " len:" + len);
		StringBuilder sb = new StringBuilder();
		for (int i = start; i < start + len; i++) {
			sb.append(String.format("%X ", s[i] & 0xff));
			sb.append(" ");
		}
		return sb.toString();
	}

}
